''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 79

from karel.robota import UrRobot
from karel.robota import East

def doManyMoves(robot):
    robot.move()
    robot.move()
    robot.move()
        
class TwoMover(UrRobot):
    def move(self):
        UrRobot.move(self)
        UrRobot.move(self)
            
if __name__ == '__main__' :
    karel = UrRobot(1, 1, East, 0)
    carol = TwoMover(2, 1, East, 0)
    carl  = TwoMover(3, 1, East, 0)
    karl = UrRobot(4, 1, East, 0)
    kurl = TwoMover(5, 1, East, 0)

    karel.move() # 1 block
    carol.move() # 2 blocks
    UrRobot.move(carl) # 1 block
    doManyMoves(karl)  # 3 blocks
    doManyMoves(kurl)  # 6 blocks
