''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 97

class ObservablePicker(UrRobot) :
    def __init__(self, street, avenue, direction, beepers):
        UrRobot.__init__(self, street, avenue, direction, beepers)
        self.__listener = NullListener()


    def register(self, listener) :   
        self.__listener = listener
    

    def pickBeeper(self):
        UrRobot.pickBeeper(self)
        self.__listener.update()
