''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 188

class Mathematician(Robot, Turner) :
    def zigLeftUp(self):
        #Precondition: facingWest and frontIsClear
        #Postcondition facingWest
        self.move();
        self.turnRight()
        self.move()
        self.turnLeft()
        
    def zagDownRight(self):
        #Precondition facingSouth and FrontIsClear
        #Postcondition facingSouth
        self.move()
        self.turnLeft()
        self.move()
        self.turnRight()

    def findBeeper(self):
        self.goToOrigin()
        self.faceWest()
        while not self.nextToABeeper() :
            if self.facingWest() :
                self.zigMove()
            else :
                self.zagMove()

    def zigMove(self):
        #Precondition facingWest
        if self.frontIsClear() :
            self.zigLeftUp()
        else :
            self.advanceToNextDiagonal()

    def zagMove(self):
        #Precondition facingSouth
        if self.frontIsClear() :
            self.zagDownRight()
        else :
            self.advanceToNextDiagonal()

    def advanceToNextDiagonal(self):
        if self.facingWest() :
            self.faceNorth()
        else :
            self.faceEast()
        self.move()
        self.turnAround()
