''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 35

from karel.robota import UrRobot
from karel.robota import East
class StairSweeper(UrRobot):    
    def turnRight(self):
        "Robot turns right by executing three turnLeft instructions"
        self.turnLeft()
        self.turnLeft()
        self.turnLeft()
        
    def climbStair(self):
        "Robot climbs one stair"
        self.turnLeft()
        self.move()
        self.turnRight()
        self.move()
        
if __name__ == '__main__':    
    alex = StairSweeper(1, 1, East, 0)
    alex.climbStair()
    alex.pickBeeper()
    alex.climbStair()
    alex.pickBeeper()
    alex.climbStair()
    alex.pickBeeper()
    alex.turnOff()