''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 92

class Accomplice(UrRobot):
    """Maintains a strategy object that it will hand-off to a Spy"""

    def __init__(self, street, avenue, direction, beepers, strategy):
        UrRobot.__init__(self, street, avenue, direction, beepers)
        self.__clue = strategy
        
    def requestClue(self):
        "Give the strategy to whichever object asks for it -- a Spy" 
        return self.__clue