""" Copyright 2008 Joseph Bergin
License: Creative Commons Attribution-Noncommercial-Share Alike 3.0 United States License

Strategy objects to illustrate delegation. These put varying number of beepers
when asked to "doIt"
"""

from strategy import Strategy

class TwoBeeperStrategy(Strategy):
    "A strategy for putting two beepers on a corner"
    def doIt(self, robot):
        robot.putBeeper()
        robot.putBeeper()
        
        
class ThreeBeeperStrategy(Strategy):
    "A strategy for putting three beepers on a corner"
    def doIt(self, robot):
        robot.putBeeper()
        robot.putBeeper()
        robot.putBeeper()
