''' Copyright 1997 Joseph Bergin
This may be reproduced, shared, modified for any educational purpose with attribution 
'''

#pg 90

class BlockWalker(UrRobot) :

    def __init__(self, street, avenue, direction, beepers) :
        UrRobot.__init__(self, street, avenue, direction, beepers)
        self.__strategy = self.ThreeBlockStrategy()
        self.__otherStrategy = self.TwoBlockStrategy()

    def walkASide(self) :
        self.__strategy.doIt(self)
        self.__strategy, self.__otherStrategy = \
        	self.__otherStrategy, self.__strategy

    class TwoBlockStrategy(Strategy):
        def doIt(self, robot):
            robot.move()
            robot.move()
            
    class ThreeBlockStrategy(Strategy):
        def doIt(self, robot):
            robot.move()
            robot.move()
            robot.move()
