
from copy import copy
from karel.robota import UrRobot
from karel.robota import world
from karel.robota import North


class RentAJobber :
    ''' supplies lists of no argument functions to be executed by a client'''
    def __init__(self):
        self.__actions = []
        self.__actions.append(advert)
        
    def addAction(self, action):
        self.__actions.append(action)
        
        
    def rent(self):
        return copy(self.__actions) #Don't let the client modify __actions.

def advert():
    print ("Rich's rent a job")
    
def task():
    rich = RentAJobber()
    worker = UrRobot(1, 1, North, 1)
    rich.addAction(worker.move)
    rich.addAction(worker.turnLeft)
    worker = UrRobot(1, 2, North, 0)
    rich.addAction(worker.move)
    rich.addAction(worker.move)
    
    world.setDelay(30)
    
    something = rich.rent()
    for f in something :
        f()
        
if __name__ == '__main__' :    
    from karel.robota import window
    world.setSize(12,12)
    window().run(task) #note the robot is created within the task
